<!DOCTYPE html>
<html lang="en">
   <head>
      <meta charset="UTF-8">
      <meta name="viewport" content="width=device-width, initial-scale=1.0">
      <title>Sitemap Generator</title>
      <link href="css/bootstrap.min.css" rel="stylesheet">
      <style>
         .input-group {
         margin-bottom: 1rem;
         }
         .btn-generate {
         background-color: #007bff;
         color: #fff;
         transition: all 0.3s ease;
         }
         .btn-generate:hover {
         background-color: #0056b3;
         }
      </style>
   </head>
   <body>
      <header class="bg-dark text-light p-3">
         <div class="container">
            <h1>Sitemap Generator</h1>
         </div>
      </header>
      <div class="container mt-5">
         <div class="row">
            <div class="col-lg-12">
               <form method="post">
                  <div class="input-group mb-3">
                     <input type="text" class="form-control" placeholder="Enter Site URL" name="site_url" required>
                     <button class="btn btn-primary btn-generate" type="submit">Generate</button>
                  </div>
               </form>
            </div>
         </div>
         <div id="result">
            <?php
               function generateRandomString($length = 10) {
                   $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
                   $randomString = '';
                   for ($i = 0; $i < $length; $i++) {
                       $randomString .= $characters[rand(0, strlen($characters) - 1)];
                   }
                   return $randomString;
               }
               
               function createSitemap($siteUrl) {
                   date_default_timezone_set('UTC');
               
                   $randomString = generateRandomString(8);
                   $sitemapFile = 'sitemap_' . date('Y-m-d_H-i-s') . '_' . $randomString . '.xml';
               
                   $xml = '<?xml version="1.0" encoding="UTF-8"?>' . PHP_EOL;
            $xml .= '
            <urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">
               ' . PHP_EOL;
               if (strpos($siteUrl, 'http://') !== 0 && strpos($siteUrl, 'https://') !== 0) {
               $siteUrl = 'http://' . $siteUrl;
               }
               $html = @file_get_contents($siteUrl);
               if ($html === false) {
               echo "Error: '$siteUrl' no address.";
               return;
               }
               $dom = new DOMDocument();
               @$dom->loadHTML($html);
               $xpath = new DOMXPath($dom);
               $links = $xpath->query('//a/@href');
               foreach ($links as $link) {
               $url = trim($link->nodeValue);
               $xml .= "\t
               <url>
                  \n\t\t
                  <loc>$url</loc>
                  \n\t\t
                  <lastmod>" . date('c') . "</lastmod>
                  \n\t\t
                  <priority>0.80</priority>
                  \n\t
               </url>
               \n";
               }
               $xml .= '
            </urlset>
            ';
            file_put_contents($sitemapFile, $xml);
            echo 'Sitemap.xml file created. <br>';
            echo 'Download: <a href="' . $sitemapFile . '">sitemap.xml</a>';
            }
            if (isset($_POST['site_url'])) {
            $siteUrl = $_POST['site_url'];
            createSitemap($siteUrl);
            }
            ?>
         </div>
		 <footer>
		 <div class="container text-center">
		 <a href="https://www.templatetop.com" class="link-dark">free templates</a>
		 </div>
		 </footer>
		 <script src="js/bootstrap.bundle.min.js"></script>
      </div>
   </body>
</html>